package cn.iocoder.yudao.module.ecw.dal.dataobject.currencyRate;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.type.JsonLongSetTypeHandler;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.ToString;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Set;

/**
 * 货币汇率 DO
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_currency_rate")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CurrencyRateDO extends BaseDO {
    /**
     *
     */
    @TableId
    private Long id;

    /**
     * 原币种
     */
    private Long sourceId;

    /**
     * 支付币种
     */
    private Long targetId;

    /**
     * 原币种金额
     */
    private BigDecimal sourceAmount;

    /**
     * 支付币种金额
     */
    private BigDecimal targetAmount;

    /**
     * 汇率值
     */
    private BigDecimal rate;

    /**
     * 国家
     */
    @TableField(typeHandler = JsonLongSetTypeHandler.class)
    private Set<Long> countries;

    /**
     * 有效期
     */
    private LocalDate expiration;

    /**
     * 备注
     */
    private String remarks;
}
